#-------- delete empty tail
Tail<-function(x){
  ll<-"абвгдежзийклмнопрстуфхцчшщъыьэюя"
  ll<-substring(ll,1:nchar(ll),1:nchar(ll))
  s<-substring(x,1:nchar(x),1:nchar(x)); s[length(s)]
  paste(s[s %in% ll],collapse="")

}
#---------------
Clea<-function(w)
{
  L<-"АБИГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЭЮЯ"
  l<-"абвгдежзийклмнопрстуфхцчшщэюя"
  ll<-"абвгдежзийклмнопрстуфхцчшщъыьэюя"
  dfL<-data.frame(L=substring(L,1:nchar(L),1:nchar(L)),
                  l=substring(l,1:nchar(L),1:nchar(L)))
  
  
  w<-gsub("[.]","",w);w
  w<-gsub(",","",w);w
  w<-gsub(",","",w);w
  w<-gsub("!","",w);w
  w<-gsub("-"," ",w);w
  w<-gsub("—"," ",w);w
  w<-gsub("…"," ",w);w
  w<-gsub(":","",w);w
  w<-gsub("[?]"," ",w);w
  #w<-gsub(" \ ","",w) ;w
  w<-gsub(")", "",w);w
  
  W<-strsplit(w, " ")
  table(W)
  
  S<-as.character(sapply(W[[1]],function(w1){
    
    a1<-substr(w1,1,1);
    if(a1 %in% dfL[,"L"] | a1 %in% dfL[,"l"])
      res<-ifelse(a1 %in% dfL[,"L"] & a1!="",gsub(a1,dfL[which(dfL[,"L"]==a1),"l"],w1),w1) 
    else res<-""
    Tail(res)
  }))
  
  S<-S[S!=""] 
  #delete empty tail
  table(S)
  S
  
}


#---------






Wocabolario<-function(W2,k)
{
  X<-do.call('c',W2)
  tab<-table(X)
  names(tab)[tab>k]
}
########

EstNB<-function(x)
{
  
  minuslogl2 <- function(prob,  x) 
    -sum(dnbinom(x = x, size = prob*mean(x)/(1-prob), prob = prob, log = TRUE))
  
  
  
  res<-optimize(minuslogl2,c(0,1),x=x)
  prob.<-res$minimum;prob.
  size.<-prob.*mean(x)/(1-prob.)
  c(size.=size.,prob.=prob.)
}
#####################
PrNB<-function(p,k,t)
{
  return( dnbinom(0:t, size=k, prob=p))
}
#############
Modelling<-function(fun,param,n)
{
  H<-fun(n,param)
  return(H)
}
##################

DistFitsUnknow<-function(X)
{
  tau<-EstNB(X);tau
  
  if(tau[2]>0 & tau[2]<1 & tau[1]>0)
    return(c(tau=tau,plevel=DistFits(X,tau) )) 	else
      return(c(tau=tau,plevel=NA))
  
}

##############



DistFits<-function(X,params)
{
  T<-table(X)
  t<-max( as.numeric(names(T))  )
  prob<-PrNB(params[2],params[1],t)
  
  f<-stepfun( z<-0:t,c(0, cumsum(prob)))
  return(  cvm.test(X,f)$p.value  )
}

###############

PlevelBootStrap<-function(X,funEst,funMod,funProb,nBoot)
{
  params<-funEst(X)
  
  tau0<-params[1:2]
  p0<-DistFits(X,tau0)
  #print(params)
  if(params[2]>0 & params[2]<1 & params[1]>0 & p0!='NA')
  {
    Xmod<-matrix(rnbinom(length(X)*nBoot,prob=params[2],size=params[1]),ncol=nBoot)
    nrow(Xmod)
    ncol(Xmod)
    P<-t(apply(Xmod,2,DistFitsUnknow))
    plevels<-na.omit(P[,3])
    length(plevels)
    
    V<-c(tau0,p0=p0,plevel=length(plevels[plevels>p0])/length(plevels))   } else
      V<-  c(tau0,p0=p0,plevel=NA)   
  return(  V  )
  
}


##############################

W1<-readLines("~/Documents/share/R/NB/NB2/bisset.txt",encoding="UTF-8")

W2<-lapply(W1,function(x)Clea(x[[1]]))
W2T<-lapply(W2,function(x)table(x))
WB<-Wocabolario(W2,k=7)


L0<-lapply(WB,function(word) unlist(lapply(W2T,function(t) ifelse(word %in% names(t),t[word],0))) )
X<-data.frame(L0); colnames(X)<-WB


ee<-apply(X,2,function(x)(sd(x))^2/mean(x))
X<-X[,names(ee[ee>1])]

R<-apply(X,2,function(x)PlevelBootStrap(x,EstNB,rnbinom,PrNB,nBoot=30))
dfR<-data.frame(t(R))

 dfR<-dfR[dfR$plevel>0.2 & dfR$size.<20,] 
  
 plot(dfR$size.,dfR$prob.,type="n",xlab="size",ylab="prob")
  text(dfR$size.,dfR$prob.,row.names(dfR),cex=0.7)

  

  plot(dfR$size.,dfR$prob.,type="n",xlim=c(0,0.02),ylim=c(0,0.051),xlab="size",ylab="prob")
  text(dfR$size.,dfR$prob.,row.names(dfR),cex=0.7)
  
  
  xtable(dfR[dfR$size.<0.05 & dfR$prob.<0.034,],digits=4)
  